diff --git a/app/test/test_cmdline_cirbuf.c b/app/test/test_cmdline_cirbuf.c
index 8ac326cb02e0..6f7aae6df59a 100644
--- a/app/test/test_cmdline_cirbuf.c
+++ b/app/test/test_cmdline_cirbuf.c
@@ -708,7 +708,7 @@ test_cirbuf_char_fill(void)
 		return -1;
 	}
 	/* delete buffer from tail */
-	for(i = 0; i < CMDLINE_TEST_BUFSIZE; i++)
+	for (i = 0; i < CMDLINE_TEST_BUFSIZE; i++)
 		cirbuf_del_tail_safe(&cb);
 	/* try to delete from an empty buffer */
 	if (cirbuf_del_tail_safe(&cb) >= 0) {
@@ -737,7 +737,7 @@ test_cirbuf_char_fill(void)
 		return -1;
 	}
 	/* delete buffer from head */
-	for(i = 0; i < CMDLINE_TEST_BUFSIZE; i++)
+	for (i = 0; i < CMDLINE_TEST_BUFSIZE; i++)
 		cirbuf_del_head_safe(&cb);
 	/* try to delete from an empty buffer */
 	if (cirbuf_del_head_safe(&cb) >= 0) {
diff --git a/app/test/test_debug.c b/app/test/test_debug.c
index 2704f5b92726..c66748019d9f 100644
--- a/app/test/test_debug.c
+++ b/app/test/test_debug.c
@@ -53,7 +53,7 @@ test_panic(void)
 		return -1;
 	}
 	wait(&status);
-	if(status == 0){
+	if (status == 0){
 		printf("Child process terminated normally!\n");
 		return -1;
 	} else
@@ -84,7 +84,7 @@ test_exit_val(int exit_val)
 	}
 	wait(&status);
 	printf("Child process status: %d\n", status);
-	if(!WIFEXITED(status) || WEXITSTATUS(status) != (uint8_t)exit_val){
+	if (!WIFEXITED(status) || WEXITSTATUS(status) != (uint8_t)exit_val){
 		printf("Child process terminated with incorrect status (expected = %d)!\n",
 				exit_val);
 		return -1;
diff --git a/app/test/test_hash.c b/app/test/test_hash.c
index 3e45afaa67fc..5e0618f0c340 100644
--- a/app/test/test_hash.c
+++ b/app/test/test_hash.c
@@ -72,7 +72,7 @@ static uint32_t hashtest_key_lens[] = {0, 2, 4, 5, 6, 7, 8, 10, 11, 15, 16, 21,
 		rte_free(g_qsv);					\
 		return -1;						\
 	}								\
-} while (0)
+} while(0)
 
 /*
  * 5-tuple key type.
@@ -724,12 +724,12 @@ static int test_five_keys(void)
 	}
 
 	/* Lookup */
-	for(i = 0; i < 5; i++)
+	for (i = 0; i < 5; i++)
 		key_array[i] = &keys[i];
 
 	ret = rte_hash_lookup_bulk(handle, &key_array[0], 5, (int32_t *)pos);
-	if(ret == 0)
-		for(i = 0; i < 5; i++) {
+	if (ret == 0)
+		for (i = 0; i < 5; i++) {
 			print_key_info("Lkp", key_array[i], pos[i]);
 			RETURN_IF_ERROR(pos[i] != expected_pos[i],
 					"failed to find key (pos[%u]=%d)", i, pos[i]);
diff --git a/app/test/test_lpm6_perf.c b/app/test/test_lpm6_perf.c
index aaf2773b6fac..2f9321345e4b 100644
--- a/app/test/test_lpm6_perf.c
+++ b/app/test/test_lpm6_perf.c
@@ -47,7 +47,7 @@ print_route_distribution(const struct rules_tbl_entry *table, uint32_t n)
 	printf("--------------------------- \n");
 
 	/* Count depths. */
-	for(i = 1; i <= 128; i++) {
+	for (i = 1; i <= 128; i++) {
 		unsigned depth_counter = 0;
 		double percent_hits;
 
diff --git a/app/test/test_malloc.c b/app/test/test_malloc.c
index de40e506113a..0bb18c8cf7aa 100644
--- a/app/test/test_malloc.c
+++ b/app/test/test_malloc.c
@@ -86,8 +86,8 @@ test_align_overlap_per_lcore(__rte_unused void *arg)
 			ret = -1;
 			break;
 		}
-		for(j = 0; j < 1000 ; j++) {
-			if( *(char *)p1 != 0) {
+		for (j = 0; j < 1000 ; j++) {
+			if ( *(char *)p1 != 0) {
 				printf("rte_zmalloc didn't zero the allocated memory\n");
 				ret = -1;
 			}
@@ -157,8 +157,8 @@ test_reordered_free_per_lcore(__rte_unused void *arg)
 			ret = -1;
 			break;
 		}
-		for(j = 0; j < 1000 ; j++) {
-			if( *(char *)p1 != 0) {
+		for (j = 0; j < 1000 ; j++) {
+			if ( *(char *)p1 != 0) {
 				printf("rte_zmalloc didn't zero the allocated memory\n");
 				ret = -1;
 			}
@@ -331,12 +331,12 @@ test_multi_alloc_statistics(void)
 	/* After freeing both allocations check stats return to original */
 	rte_malloc_get_socket_stats(socket, &post_stats);
 
-	if(second_stats.heap_totalsz_bytes != first_stats.heap_totalsz_bytes) {
+	if (second_stats.heap_totalsz_bytes != first_stats.heap_totalsz_bytes) {
 		printf("Incorrect heap statistics: Total size \n");
 		return -1;
 	}
 	/* Check allocated size is equal to two additions plus overhead */
-	if(second_stats.heap_allocsz_bytes !=
+	if (second_stats.heap_allocsz_bytes !=
 			size + overhead + first_stats.heap_allocsz_bytes) {
 		printf("Incorrect heap statistics: Allocated size \n");
 		return -1;
@@ -495,7 +495,7 @@ test_realloc_socket(int socket)
 		return -1;
 	}
 	/* calc an alignment we don't already have */
-	while(RTE_PTR_ALIGN(ptr7, new_align) == ptr7)
+	while (RTE_PTR_ALIGN(ptr7, new_align) == ptr7)
 		new_align *= 2;
 	char *ptr8 = rte_realloc_socket(ptr7, size7, new_align, socket);
 	if (!ptr8){
diff --git a/app/test/test_mbuf.c b/app/test/test_mbuf.c
index 53fe898a384c..d505fd25e022 100644
--- a/app/test/test_mbuf.c
+++ b/app/test/test_mbuf.c
@@ -120,7 +120,7 @@ static unsigned refcnt_lcore[RTE_MAX_LCORE];
 		printf("mbuf test FAILED (l.%d): <" str ">\n",		\
 		       __LINE__,  ##__VA_ARGS__);			\
 		goto fail;						\
-} while(0)
+} while (0)
 
 /*
  * test data manipulation in mbuf with non-ascii data
@@ -154,7 +154,7 @@ test_pktmbuf_with_non_ascii_data(struct rte_mempool *pktmbuf_pool)
 	return 0;
 
 fail:
-	if(m) {
+	if (m) {
 		rte_pktmbuf_free(m);
 	}
 	return -1;
@@ -701,12 +701,12 @@ test_pktmbuf_pool(struct rte_mempool *pktmbuf_pool)
 	}
 	struct rte_mbuf *extra = NULL;
 	extra = rte_pktmbuf_alloc(pktmbuf_pool);
-	if(extra != NULL) {
+	if (extra != NULL) {
 		printf("Error pool not empty");
 		ret = -1;
 	}
 	extra = rte_pktmbuf_clone(m[0], pktmbuf_pool);
-	if(extra != NULL) {
+	if (extra != NULL) {
 		printf("Error pool not empty");
 		ret = -1;
 	}
@@ -966,7 +966,7 @@ test_pktmbuf_free_segment(struct rte_mempool *pktmbuf_pool)
 			struct rte_mbuf *mb, *mt;
 
 			mb = m[i];
-			while(mb != NULL) {
+			while (mb != NULL) {
 				mt = mb;
 				mb = mb->next;
 				rte_pktmbuf_free_seg(mt);
@@ -1195,7 +1195,7 @@ verify_mbuf_check_panics(struct rte_mbuf *buf)
 		return -1;
 	}
 	wait(&status);
-	if(status == 0)
+	if (status == 0)
 		return -1;
 
 	return 0;
diff --git a/app/test/test_spinlock.c b/app/test/test_spinlock.c
index 3f59372300c3..3ee82fa963a5 100644
--- a/app/test/test_spinlock.c
+++ b/app/test/test_spinlock.c
@@ -237,7 +237,7 @@ test_spinlock(void)
 	/*
 	 * Try to acquire a lock that we already own
 	 */
-	if(!rte_spinlock_recursive_trylock(&slr)) {
+	if (!rte_spinlock_recursive_trylock(&slr)) {
 		printf("rte_spinlock_recursive_trylock failed on a lock that "
 		       "we already own\n");
 		ret = -1;